pro tcp3DrawEvent,event

widget_control,event.top,get_uvalue=statePtr

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro top3BaseEvent,event
;event handler for when the arrow buttons are pressed

;nothing special to do for this example.

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro tcp3BaseEvents,event
widget_Control, event.top, get_uvalue=statePtr

if tag_names(event,/struct) eq 'WIDGET_TAB' then return

deltaX = event.x - (*statePtr).xsize
deltaY = event.y - (*statePtr).ysize
eventStruct = {KRSPLITPANE_RESIZE, ID:(*statePtr).paneID, TOP:event.top, HANDLER:event.handler,$
                                    xsize:event.x, ysize:event.y}

void = call_function('krsplitpane_resize_event',eventStruct)

;use this find_by_uname method to get the second pane widget id
paneID2 = widget_info(event.top, find_by_uname='paneID2')
eventStruct = {KRSPLITPANE_RESIZE, ID:paneID2, TOP:event.top, HANDLER:event.handler,$
                                    xsize:event.x, ysize:event.y}

void = call_function('krsplitpane_resize_event',eventStruct)

(*statePtr).xsize = event.x
(*statePtr).ysize = event.y

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro left3EventPro,event
widget_Control, event.top, get_uvalue=statePtr
;print,(*statePtr).currentLeftXSize
(*statePtr).currentLeftXSize =  event.xsize
(*statePtr).currentLeftYSize =  event.ysize

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro right3EventPro,event
widget_Control, event.top, get_uvalue=statePtr
(*statePtr).currentRightXSize = event.xsize
(*statePtr).currentRightYSize = event.ysize

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro left3_createpro, base

tabId = widget_tab(base,xs=300,ys=300)

wT1 = widget_base(tabId, TITLE='Tab 1', /COLUMN)
wT2 = widget_base(tabId, TITLE='Tab 2', /COLUMN)

treeId2 = widget_tree(wT1,ysize=100)
wtLeaf11 = widget_tree(treeId2, value='Atmospheric Charactization')
wtBranch1 = widget_tree(treeId2, value='Background Estimation',/folder,/expanded)
wtLeaf12 = widget_tree(wtBranch1, value='Background Estimate 1')
wtLeaf13 = widget_tree(wtBranch1, value='Background Estimate 2')
wtLeaf14 = widget_tree(treeId2, value='Detection')

treeId3 = widget_tree(wT2,ysize=75)
wtLeaf11 = widget_tree(treeId3, value='Script 1')
wtLeaf12 = widget_tree(treeId3, value='Script 2')
wtLeaf13 = widget_tree(treeId3, value='Script 3')

;control buttons
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Clear Run',xsize=100)
void = widget_button(subBase,value='Branch',xsize=100)
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Run Script',xsize=100)
void = widget_button(subBase,value='Run Step',xsize=100)
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Run Subtree',xsize=100)
void = widget_button(subBase,value='Validity Check',xsize=100)

void = widget_button(wT1,value='Run All Scripts')
void = widget_button(wT1,value='Quit')

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro top3EventPro, event


return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro bottom3EventPro, event


return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro top3_createpro, base

subBase = widget_base(base, column=1)
void = widget_button(subBase,value='Run All Scripts')
void = widget_button(subBase,value='Quit')

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro bottom3_createpro, base

subBase = widget_base(base, column=1)
void = widget_button(subBase,value='Run All Scripts')
void = widget_button(subBase,value='Quit')

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro right3_createpro, base

subBase = widget_base(base,column=1)

xsize = 300
ysize = 150
paneID2 =  krSplitPane( subBase, topCreatePro='top3_createpro', $
                   bottomCreatePro='bottom3_createpro', $
                   topEventPro='top3EventPro', $
                   bottomEventPro='bottom3EventPro', $
                   topBaseEventPro='top3Event', $
                   topXsize=xsize,topySize=ysize, $
                   bottomXsize=xsize,bottomYsize=ysize, $
                   orientation='horizontal',topMinSize=50, $
                   uname='paneID2')

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro testCreate3Panes

base = widget_base(row=1,title='pane test',tlb_size_events=1)

xsize = 350
ysize = 350
orientation = 'vertical'
paneID =  krSplitPane( base, leftCreatePro='left3_createpro', $
                   rightCreatePro='right3_createpro', $
                   leftEventPro='left3EventPro', $
                   rightEventPro='right3EventPro', $
                   topBaseEventPro='top3BaseEvent', $
                   leftXsize=xsize,leftySize=ysize, $
                   rightXsize=xsize,rightYsize=ysize, $
                   leftMinSize=250, $
                   orientation=orientation,topMinSize=250)

widget_control, base, /realize


geom = widget_info(base,/geom)
state = { leftMinSize : 250, $
          currentLeftXSize:xsize, $
          currentLeftYSize:ysize, $
          currentRightXSize : xsize, $
          currentRightYSize : ysize, $
          xsize:geom.xsize, $
          ysize:geom.ysize, $
          paneID: paneID}

widget_control,base,set_uvalue=ptr_new(state)
xmanager,'testCreate3Panes',base,/no_block, event_handler='tcp3BaseEvents'

return & end