pro tcpDrawEvent,event

widget_control,event.top,get_uvalue=statePtr

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro topBaseEvent,event
;event handler for when the arrow buttons are pressed

;nothing special to do for this example.

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro tcpBaseEvents,event
widget_Control, event.top, get_uvalue=statePtr

if tag_names(event,/struct) eq 'WIDGET_TAB' then return

;deltas just in case you need them
deltaX = event.x - (*statePtr).xsize
deltaY = event.y - (*statePtr).ysize
eventStruct = {KRSPLITPANE_RESIZE, ID:(*statePtr).paneID, TOP:event.top, HANDLER:event.handler,$
                                    xsize:event.x, ysize:event.y}
;you have to pass the resize event back to the krSplitPane widget
void = call_function('krsplitpane_resize_event',eventStruct)

(*statePtr).xsize = event.x
(*statePtr).ysize = event.y

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro leftEventPro,event
widget_Control, event.top, get_uvalue=statePtr
;just save the size for this side
(*statePtr).currentLeftXSize = event.xsize
(*statePtr).currentLeftYSize = event.ysize

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro rightEventPro,event
widget_Control, event.top, get_uvalue=statePtr

;save the size and use it to redisplay the image
(*statePtr).currentRightXSize = event.xsize
(*statePtr).currentRightYSize = event.ysize

widget_control,/hourglass
widget_control, widget_info(event.top,find_by_uname='drawId'),draw_xsize=(*statePtr).currentRightXSize, $
				draw_ysize=(*statePtr).currentRightYSize

if ((*statePtr).currentRightXSize gt 0) and ((*statePtr).currentRightYSize gt 0) then $
  tv, dist((*statePtr).currentRightXSize,(*statePtr).currentRightYSize)

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro left_createpro, base
;regular widget building program that the krSplitPane compound widget calls
tabId = widget_tab(base,xs=300,ys=300)

wT1 = widget_base(tabId, TITLE='Tab 1', /COLUMN)
wT2 = widget_base(tabId, TITLE='Tab 2', /COLUMN)

treeId2 = widget_tree(wT1,ysize=100)
wtLeaf11 = widget_tree(treeId2, value='Atmospheric Charactization')
wtBranch1 = widget_tree(treeId2, value='Background Estimation',/folder,/expanded)
wtLeaf12 = widget_tree(wtBranch1, value='Background Estimate 1')
wtLeaf13 = widget_tree(wtBranch1, value='Background Estimate 2')
wtLeaf14 = widget_tree(treeId2, value='Detection')

treeId3 = widget_tree(wT2,ysize=75)
wtLeaf11 = widget_tree(treeId3, value='Script 1')
wtLeaf12 = widget_tree(treeId3, value='Script 2')
wtLeaf13 = widget_tree(treeId3, value='Script 3')

;control buttons
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Clear Run',xsize=100)
void = widget_button(subBase,value='Branch',xsize=100)
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Run Script',xsize=100)
void = widget_button(subBase,value='Run Step',xsize=100)
subBase = widget_base(wT1,row=1)
void = widget_button(subBase,value='Run Subtree',xsize=100)
void = widget_button(subBase,value='Validity Check',xsize=100)

void = widget_button(wT1,value='Run All Scripts')
void = widget_button(wT1,value='Quit')

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro right_createpro, base
;regular widget building program that the krSplitPane compound widget calls
drawiD = widget_draw(base,xs=350,ys=350,uname='drawId',graphics_level=0,/motion_events, $
					 /button_events, /expose_events, event_pro='tcpDrawEvent')
widget_control,drawiD, get_value=winId
wset, winID
tv, dist(350,350)
return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro tcpCleanup,base

widget_control, base, get_uvalue=statePtr
ptr_free, statePtr

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro testCreatePanes

base = widget_base(row=1,title='pane test',tlb_size_events=1)

xsize = 350
ysize = 350
orientation = 'vertical'
;orientation = 'horizontal'

;you can specify either procedures or functions as event handlers
paneID =  krSplitPane( base, leftCreatePro='left_createpro', $
                   rightCreatePro='right_createpro', $
                   leftEventPro='leftEventPro', $
                   ;LEFT_EVENT_FUNC='leftEventFunc', $
                   rightEventPro='rightEventPro', $
                   ;RIGHT_EVENT_FUNC='rightEventFunc', $
                   topBaseEventPro='topBaseEvent', $
                   ;TOP_EVENT_FUNC='topEventFunc', $
                   leftXsize=xsize,leftySize=ysize, $
                   rightXsize=xsize,rightYsize=ysize, $
                   leftMinSize=250, $
                   orientation=orientation,topMinSize=250)

widget_control, base, /realize

geom = widget_info(base,/geom)
state = { leftMinSize : 250, $
          currentLeftXSize:xsize, $
          currentLeftYSize:ysize, $
          currentRightXSize : xsize, $
          currentRightYSize : ysize, $
          xsize:geom.xsize, $
          ysize:geom.ysize, $
          paneID:paneID }

widget_control,base,set_uvalue=ptr_new(state)
xmanager,'testCreatePanes',base,/no_block, event_handler='tcpBaseEvents', $
         cleanup='tcpCleanup'

return & end