pro krSplitPaneButton,event

widget_control, widget_info(event.id,/parent), get_uvalue=self
self->collapseButtonEvent, event

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPaneDying, base

widget_control, base, get_uvalue=self
obj_destroy, self

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krsplitpane_resize_event,event

child = widget_info(event.id,/child)
widget_control, child, get_uvalue=self

self->resize, event

return,event
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPaneLine,event

widget_control,event.id,get_uvalue=self

self->moveBar, event

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPaneRealize, id

widget_control,id,get_uvalue=self
self->createBar, id

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::resizeSliderBar, xsize, ysize
;creates a new bar image and puts in in the image object

image = self->createBarImage(xsize, ysize)
oImage = self.oContainer->get(/all,isa='IDLgrImage')
oImage->setProperty,data=image

oView = self.oContainer->get(/all,isa='IDLgrView')
oView->setProperty, viewplane_rect=[0,0,xsize,ysize]

widget_control, self.line, get_value=oWin
oWin->draw, oView

return & end


;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::collapseButtonEvent, event
;handles collapse button events

;;get geometry for line
infoline = widget_info(self.lineBase,/geometry)

widget_control,event.id, get_uvalue=button
if button eq 'left' then begin
  if self.visible eq 'both' then begin
    if self.orientation eq 'vertical' then begin
      self.restoreLeftSize = self.leftXsize
      self.rightXsize = self.rightXsize + self.leftXsize
      self.leftXsize = 0
      widget_control, self.lineBase,xoffset = 0
      widget_control,self.rightBase,xoffset=infoline.scr_xsize
    endif else if self.orientation eq 'horizontal' then begin
      self.restoreRightSize = self.rightXsize
      self.leftYsize = self.leftYsize + self.rightYsize
      self.rightYsize = 0
      widget_control, self.lineBase,yoffset = self.leftYsize
      widget_control,self.leftBase,yoffset = 0
    endif
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonLeft'), $
                    sensitive=0
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonRight'), $
                    sensitive=1
    self.visible = 'right'
  endif else if self.visible eq 'left' then begin
    if self.orientation eq 'vertical' then begin
      self.rightXsize = self.restoreRightSize
      self.leftXsize = (self.leftXsize - self.rightXsize) > 0
      widget_control,self.leftBase,xoffset=0
      widget_control, self.lineBase,xoffset = self.leftXsize
      widget_control,self.rightBase,xoffset=self.leftXsize + infoline.scr_xsize
    endif else if self.orientation eq 'horizontal' then begin
       self.leftYsize = self.restoreLeftSize
       self.rightYsize = (self.rightYsize - self.leftYsize) > 0
       widget_control,self.leftBase,yoffset=0
       widget_control, self.lineBase,yoffset = self.leftYsize
       widget_control,self.rightBase,yoffset = self.leftYsize + infoline.scr_ysize

    endif
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonLeft'), $
                    sensitive=1
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonRight'), $
                    sensitive=1
    self.visible = 'both'
  endif
endif else if button eq 'right' then begin
  if self.visible eq 'both' then begin
    if self.orientation eq 'vertical' then begin
      self.restoreRightSize = self.rightXsize
      self.leftXsize = self.leftXsize + self.rightXsize
      self.rightXsize = 0
      widget_control, self.lineBase,xoffset = self.leftXsize
      widget_control,self.leftBase,xoffset = 0
    endif else if self.orientation eq 'horizontal' then begin
      self.restoreLeftSize = self.leftYsize
      self.rightYsize = self.leftYsize + self.rightYsize
      self.leftYsize = 0
      widget_control, self.lineBase,yoffset = self.leftYsize
      widget_control,self.rightBase,yoffset = 0

    endif
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonLeft'), $
                    sensitive=1
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonRight'), $
                    sensitive=0
    self.visible = 'left'
  endif else if self.visible eq 'right' then begin
    if self.orientation eq 'vertical' then begin
      self.leftXsize = self.restoreLeftSize
      self.rightXsize = (self.rightXsize - self.leftXsize) > 0
      widget_control,self.leftBase,xoffset=0
      widget_control, self.lineBase,xoffset = self.restoreLeftSize
      widget_control,self.rightBase,xoffset=self.restoreLeftSize + infoline.scr_xsize
    endif else if self.orientation eq 'horizontal' then begin
      self.rightYsize = self.restoreRightSize
      self.leftYsize = (self.leftYsize - self.rightYsize) > 0
      widget_control,self.leftBase,yoffset=0
      widget_control, self.lineBase,yoffset = self.leftYsize
      widget_control,self.rightBase,yoffset = self.leftYsize + infoline.scr_ysize

    endif
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonLeft'), $
                    sensitive=1
    widget_control, widget_info(self.lineBase, find_by_uname='krSplitPaneButtonRight'), $
                    sensitive=1
    self.visible = 'both'
  endif
endif

widget_control,self.leftBase,xsize=self.leftXsize,ysize=self.leftYsize
;now pass on the event to the bases
child = widget_info(self.leftBase,/child)
evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.leftXsize, ysize:self.leftYsize}
if self.leftEventIsPro then call_procedure, self.leftEvent, evStruct $
       else void = call_function(self.leftEvent, evStruct)
;right side next
widget_control,self.rightBase,xsize=self.rightXsize,ysize=self.rightYsize
child = widget_info(self.rightBase,/child)
evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.rightXsize,ysize:self.rightYsize}
if self.rightEventIsPro then call_procedure, self.rightEvent, evStruct $
       else void = call_function(self.rightEvent, evStruct)

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::resize, event
;handles all resizing events

;;get geometry for line base
infoline = widget_info(self.lineBase,/geometry)

;calculate new sizes.
  if self.orientation eq 'vertical' then begin
    self.rightXsize = (event.xsize - self.leftXsize) > 0
    if self.rightXsize eq 0 then begin
      self.leftXsize = event.xsize
    endif else begin
      self.leftXsize = self.leftXsize
    endelse
    self.leftYsize = event.ysize
    self.rightYsize = event.ysize
    lineXsize = infoline.scr_xsize
    lineYsize = self.rightYsize
    xbuttonAdjust = 0
    ybuttonAdjust = 22
  endif else begin ;horizontal (left is top, right is bottom)
    self.leftXsize = event.xsize
    self.rightXsize = event.xsize
    self.rightYsize = (event.ysize - self.leftYsize) > 0
    if self.rightYsize eq 0 then begin
      self.leftYsize = event.ysize
    endif else begin
      self.leftYsize = self.leftYsize
    endelse
    lineXsize = self.rightXsize
    lineYsize =   infoline.scr_ysize
    xbuttonAdjust = 22
    ybuttonAdjust = 0
  endelse

    ;left side first
    widget_control,self.leftBase,xsize=self.leftXsize,ysize=self.leftYsize
    widget_control,self.lineBase,xsize=lineXsize,ysize=lineYsize
    widget_control,self.line,xsize=lineXsize-xbuttonAdjust,ysize=lineYsize - ybuttonAdjust
    ;set sizes of slider bars
    self->resizeSliderBar,lineXsize-xbuttonAdjust,lineYsize - ybuttonAdjust
    ;now pass on the event to the bases
    child = widget_info(self.leftBase,/child)
    evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.leftXsize, ysize:self.leftYsize}
    if self.leftEventIsPro then call_procedure, self.leftEvent, evStruct $
       else void = call_function(self.leftEvent, evStruct)
    ;right side next
    widget_control,self.rightBase,xsize=self.rightXsize,ysize=self.rightYsize
    child = widget_info(self.rightBase,/child)
    evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.rightXsize,ysize:self.rightYsize}
    if self.rightEventIsPro then call_procedure, self.rightEvent, evStruct $
       else void = call_function(self.rightEvent, evStruct)

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSplitPane::createBarImage,xsize, ysize, oWin=oWin
;creates the stippled looking bar image

image = bytarr(3,xsize, ysize)
colors = widget_info(widget_base(),/system_colors)
image[0,*,*] = colors.face_3d[0]
image[1,*,*] = colors.face_3d[1]
image[2,*,*] = colors.face_3d[2]
image[*,0,*] = 0B
image[*,xsize-1,*] = 0B
image[*,*,0] = 0B
image[*,*,ysize-1] = 0B
longDim = xsize > ysize
shortDim = xsize < ysize
indices = lindgen(longDim/4)*4 + 1
if shortDim eq xsize then begin
  image[*,shortDim/2-1,indices] = 255B
  image[*,shortDim/2,indices+1] = 0B
  if keyword_set(oWin) then oWin->setCurrentCursor,'size_ew'
endif else begin
  image[*,indices,shortDim/2-1] = 255B
  image[*,indices+1,shortDim/2] = 0B
  if keyword_set(oWin) then oWin->setCurrentCursor,'size_ns'
endelse

return, image
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::createBar, id
;called to create the bar when the widget is realized

widget_control, id, get_value=oWin
geom = widget_info(id,/geometry)
image = self->createBarImage(geom.scr_xsize, geom.scr_ysize, oWin=oWin)
oModel = obj_new('IDLgrModel')
oImage = obj_new('IDLgrImage',image,interleave=0)
oView = obj_new('IDLgrView',viewplane_rect=[0,0,geom.scr_xsize, geom.scr_ysize])
oModel->add, oImage
oView -> add, oModel
oWin->draw, oView
self.oContainer->add,[oView, oModel, oImage]

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::moveBar, event
;handles moving the bar

if event.type eq 2 then begin
  delta = [event.x,event.y] - self.curPos
  if self.orientation eq 'vertical' then begin
     xoffset = delta[0]
     yoffset = 0
  endif else begin
     xoffset = 0
     yoffset = -delta[1]
  endelse
  ;left (top) base adjustment first
  self.currOffset = self.currOffset + [xoffset,yoffset]
  self.leftXsize+=xoffset
  self.leftYsize+=yoffset
  if self.orientation eq 'vertical' then leftSize = self.leftXsize $
     else leftSize = self.leftYsize
  if leftSize gt self.leftMinSize then begin
    widget_control, self.lineBase, xoffset=self.currOffset[0], $
                                   yoffset=self.currOffset[1]
    widget_control, self.leftBase, xsize=self.leftXsize, ysize=self.leftYsize
    child = widget_info(self.leftBase,/child)
    evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.leftXsize, ysize:self.leftYsize}
    if self.leftEventIsPro then call_procedure, self.leftEvent, evStruct $
       else void = call_function(self.leftEvent, evStruct)
  endif else begin
    self.currOffset = self.currOffset - [xoffset,yoffset]
    self.leftXsize-=xoffset
    self.leftYsize-=yoffset
    xoffset = (yoffset = 0)
  endelse

  if self.rightXsize gt self.rightMinSize then begin
    widget_control,self.rightBase, xsize=(self.rightXsize-=xoffset), $
                                   ysize=(self.rightYsize-=yoffset), $
                                   xoffset=self.currOffset[0] + self.xBarFudgeFactor, $
                                   yoffset=self.currOffset[1] + self.yBarFudgeFactor
    child = widget_info(self.rightBase,/child)
    evStruct = {krSplitPaneResize, id:child, top:event.top, $
                handler:child, xsize:self.rightXsize, ysize:self.rightYsize}
    if self.rightEventIsPro then call_procedure, self.rightEvent, evStruct $
       else void = call_function(self.rightEvent, evStruct)
  endif else begin
    self.currOffset = self.currOffset - [xoffset,yoffset]
    self.rightXsize+=xoffset
    self.rightYsize+=yoffset
    xoffset = (yoffset = 0)
  endelse


endif else if event.press ge 1 then begin
  self.curPos = [event.x,event.y]
  widget_control,event.id, draw_motion_event=1

endif else if event.release ge 1 then begin
  widget_control,event.id, draw_motion_event=0

endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane::cleanup

obj_destroy, self.oContainer

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSplitPane::init, parent, leftCreatePro=leftCreatePro, $
                      rightCreatePro=rightCreatePro, leftEventPro=leftEventPro, $
                      leftEventFunction=leftEventFunction, rightEventPro=rightEventPro, $
                      rightEventFunction=rightEventFunction, topEventPro=topEventPro, $
                      topEventFunction=topEventFunction, $
                      bottomEventPro=bottomEventPro, bottomEventFunction=bottomEventFunction, $
                      leftXsize=leftXsize, leftYsize=leftYsize, $
                      rightXsize=rightXsize, rightYsize=rightYsize, $
                      margin=margin, orientation=orientation, $
                      visible=visible, uvalue=uvalue, uname=uname, $
                      widgetID=widgetID, leftMinSize=leftMinSize, $
                      rightMinSize=rightMinSize, topMinSize=topMinSize, $
                      bottomMinSize=bottomMinSize, topXsize=topXsize, $
                      topYsize=topYsize, bottomXsize=bottomXsize, $
                      bottomYsize=bottomYsize, $
                      topBaseEventPro=topBaseEventPro, $
                      topBaseEventFunction=topBaseEventFunction, $
                      topCreatePro=topCreatePro, bottomCreatePro=bottomCreatePro

if n_elements(parent) eq 0 || ~widget_info(parent,/valid) then return,0L

if n_elements(topEventPro) ne 0 then leftEventPro=topEventPro
if n_elements(topEventFunction) ne 0 then leftEventFunction=topEventFunction
if n_elements(bottomEventPro) ne 0 then rightEventPro=bottomEventPro
if n_elements(bottomEventFunction) ne 0 then rightEventFunction=bottomEventFunction
if n_elements(topCreatePro) ne 0 then leftCreatePro=topCreatePro
if n_elements(bottomCreatePro) ne 0 then rightCreatePro=bottomCreatePro

leftEventIsPro=size(leftEventPro,/type) EQ 7
self.leftevent = leftEventIsPro ? leftEventPro[0] : leftEventFunction[0]
self.leftEventIsPro = leftEventIsPro

rightEventIsPro=size(rightEventPro,/type) EQ 7
self.rightevent = rightEventIsPro ? rightEventPro[0] : rightEventFunction[0]
self.rightEventIsPro = rightEventIsPro

topBaseEventIsPro=size(topBaseEventPro,/type) EQ 7
self.topBaseEvent = topBaseEventIsPro ? topBaseEventPro[0] : topBaseEventFunction[0]
self.topBaseEventIsPro = topBaseEventIsPro


if n_elements(leftXsize) eq 0 then leftXsize = 200
if n_elements(leftYsize) eq 0 then leftYsize = 200
if n_elements(rightXsize) eq 0 then rightXsize = 200
if n_elements(rightYsize) eq 0 then rightYsize = 200

;in this code left is equivalent to top and right is bottom
;better to do this than to have another set of variables
if n_elements(topXsize) ne 0 then leftXsize=topXsize
if n_elements(topYsize) ne 0 then leftYsize=topYsize
if n_elements(bottomXsize) ne 0 then rightXsize=bottomXsize
if n_elements(bottomYsize) ne 0 then rightYsize=bottomYsize

if n_elements(leftMinSize) eq 0 then leftMinSize = 0
if n_elements(rightMinSize) eq 0 then rightMinSize = 0
;in this code left is equivalent to top and right is bottom
;better to do this than to have another set of variables
if n_elements(topMinSize) ne 0 then leftMinSize=topMinSize
if n_elements(bottomMinSize) ne 0 then rightMinSize=bottomMinSize

if n_elements(visible) eq 0 then visible='both panes'
if n_elements(margin) eq 0 then margin=15

if n_elements(orientation) eq 0 then orientation='vertical'
orientation = strlowcase(orientation)
if (strlowcase(orientation) ne 'vertical') and (strlowcase(orientation) ne 'horizontal') then return, 0L

;have to create the container early
self.oContainer = obj_new('IDL_container')

currentWindow=!d.window

self.parent = parent
self.base = widget_base(self.parent, func_get_value='krSplitPaneGet', $
                        pro_set_value='krSplitPaneSet', uvalue=self, $
                        uname=uname,event_func='krSplitPaneEvent', $
                        kill_notify='krSplitPaneDying',map=0)
widget_control, self.base,/realize
self.leftBase = widget_base(self.base, xsize=leftXsize, ysize=leftYsize, $
                            xpad=2, ypad=2)
info = widget_info(self.leftBase, /geometry)
widget_control, self.leftBase,/destroy

if orientation eq 'vertical' then begin
  xoffset = info.xoffset + info.scr_xsize + info.margin + $
            info.xpad + info.space
  yoffset = 0
  xsize=8
  ysize = leftYsize > rightYsize
  self.xBarFudgeFactor = 8 ;compensation for bar size
  self.yBarFudgeFactor = 0
  column = 1 & row = 0
  leftArrow = transpose(byte([8,12,14,15,14,12,8]))
  rightArrow = transpose(byte([1,3,7,15,7,3,1]))
  arrowXsize = 8
  arrowYsize = 11
  xbuttonAdjust = 0
  ybuttonAdjust = 22
  x_bitmap_extra = 4
endif else begin ;horizontal
  xoffset = 0
  yoffset = info.yoffset + info.scr_ysize + info.margin + $
            info.ypad + info.space
  xsize = leftXsize > rightXsize
  self.xBarFudgeFactor = 0 ;compensation for bar size
  self.yBarFudgeFactor = 8
  column = 0 & row = 1
  ysize = 8
  arrow =         [[0,0,0,0,0,0,0,0,0,0,0], $
                   [0,0,0,0,0,0,0,0,0,0,0], $
                   [0,0,0,0,0,2,0,0,0,0,0], $
                   [0,0,0,0,2,2,0,0,0,0,0], $
                   [0,0,0,2,2,2,2,0,0,0,0], $
                   [0,0,2,2,2,2,2,2,0,0,0], $
                   [0,2,2,2,2,2,2,2,2,0,0], $
                   [0,0,0,0,0,0,0,0,0,0,0]]
  leftArrow = cvttobm(arrow)
  rightArrow = cvttobm(rotate(arrow,2))
  arrowXsize = 11
  arrowYsize = 8
  xbuttonAdjust = 22
  ybuttonAdjust = 0
  x_bitmap_extra = 4
endelse

self.lineBase = widget_base(self.base, xoffset=xoffset, yoffset=yoffset, $
                  xpad=0, ypad=0, space=0,/toolbar, xsize=xsize, ysize=ysize, $
                  uname='krSplitPaneLineBase',column=column, row=row, uvalue=self)
self.currOffset = [xoffset,yoffset]

;create left arrow button
void = widget_button(self.lineBase,xsize=arrowXsize, $
                               ysize=arrowYsize,x_bitmap_extra=x_bitmap_extra, $
                               value=leftArrow, $
                               event_PRO='krSplitPaneButton',uvalue='left', $
                               uname='krSplitPaneButtonLeft')

;create right arrow button
void = widget_button(self.lineBase,xsize=arrowXsize, $
                               ysize=arrowYsize,x_bitmap_extra=4, $
                               value=rightArrow, $
                               event_PRO='krSplitPaneButton',uvalue='right', $
                               uname='krSplitPaneButtonRight')
;create sliding bar
self.line = widget_draw(self.lineBase, xsize=xsize-xbuttonAdjust, ysize=ysize-ybuttonAdjust, $
                        graphics_level=2,retain=2, /button_events, $
                        event_pro='krSplitPaneLine',notify='krSplitPaneRealize', $
                        uvalue=self)

;create left base
self.leftBase = widget_base(self.base,xsize=leftXsize, ysize=leftYsize, $
                            xpad=2, ypad=2)

;get geometry of where the slider line is
info = widget_info(self.lineBase,/geometry)
if orientation eq 'vertical' then begin
  xoffset = info.xoffset + info.scr_xsize + info.margin + $
            info.xpad + info.space
  yoffset = 0
endif else begin
  xoffset = 0
  yoffset = info.yoffset + info.scr_ysize + info.margin + $
            info.ypad + info.space
endelse

;create right base with offset
self.rightBase = widget_base(self.base,xsize=rightXsize, ysize=rightYsize, $
                             xpad=2,ypad=2,xoffset=xoffset, yoffset=yoffset)

;create right and left panes
call_procedure, leftCreatePro, self.leftBase
call_procedure, rightCreatePro, self.rightBase

widget_control, self.base, map=1

wset, currentWindow
widgetID = self.base
self.orientation = orientation
self.leftXsize = leftXsize
self.leftYsize = leftYsize
self.rightXsize = rightXsize
self.rightYsize = rightYsize

self.leftMinSize = leftMinSize
self.rightMinSize = rightMinSize

self.visible = 'both'

return,1

end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSplitPane__define

void = { krSplitPane, $
         parent : 0L, $
         base : 0L, $
         leftBase : 0L, $
         rightBase : 0L, $
         lineBase : 0L, $
         line : 0L, $
         margin : 0, $
         orientation : '', $
         leftEvent : '', leftEventIsPro : 0, $
         rightEvent : '', rightEventIsPro : 0, $
         topBaseEvent : '', topBaseEventIsPro : 0, $
         leftXsize : 0, leftYsize : 0, $
         rightXsize : 0, rightYsize : 0, $
         restoreLeftSize : 0, restoreRightSize : 0, $
         visible : '', $
         curpos : lonarr(2), $
         currOffset : lonarr(2), $
         xBarFudgeFactor : 0, $
         yBarFudgeFactor : 0, $
         leftMinSize : 0, rightMinSize : 0, $
         oContainer : obj_new() }

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSplitPane, parent, _extra=extra

objRef = obj_new('krSplitPane',parent, widgetID=widgetID, _extra=extra)

return, widgetID
end